searchNodes=[{"doc":"ByteOrderedFloat is used to encode and decode float values into big-endian-like, order-preserving binaries. Acknowledgements Big thanks to Aravind Ravi-Sulekha for a super helpful article. The description: The most significant bit is the sign bit. As all positive numbers are higher than all negative numbers, we should flip the sign bit so it’s 1 for positive numbers and 0 for negative numbers. For negative numbers, we additionally perform a bitwise NOT of the E and M bits so that larger negative numbers get sorted before smaller ones. Source: https://medium.com/@aravindet/order-preserving-encoding-for-floats-cde09c978629","ref":"ByteOrderedFloat.html","title":"ByteOrderedFloat","type":"module"},{"doc":"Decodes an ByteOrderedFloat encoded binary into a float. Examples iex&gt; { :ok , e } = ByteOrderedFloat . encode ( - 1.0 ) iex&gt; ByteOrderedFloat . decode ( e ) { :ok , - 1.0 } iex&gt; { :ok , e } = ByteOrderedFloat . encode ( 0.0 ) iex&gt; ByteOrderedFloat . decode ( e ) { :ok , 0.0 } iex&gt; { :ok , e } = ByteOrderedFloat . encode ( 1.0 ) iex&gt; ByteOrderedFloat . decode ( e ) { :ok , 1.0 } iex&gt; ByteOrderedFloat . decode ( &quot;1.0&quot; ) :error","ref":"ByteOrderedFloat.html#decode/1","title":"ByteOrderedFloat.decode/1","type":"function"},{"doc":"Encodes floats into a 8-byte binary that is float-order preserving. Examples iex&gt; ByteOrderedFloat . encode ( - 1.0 ) { :ok , &lt;&lt; 64 , 15 , 255 , 255 , 255 , 255 , 255 , 255 &gt;&gt; } iex&gt; ByteOrderedFloat . encode ( 0.0 ) { :ok , &lt;&lt; 128 , 0 , 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; } iex&gt; ByteOrderedFloat . encode ( 1.0 ) { :ok , &lt;&lt; 191 , 240 , 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; } iex&gt; ByteOrderedFloat . encode ( nil ) :error","ref":"ByteOrderedFloat.html#encode/1","title":"ByteOrderedFloat.encode/1","type":"function"},{"doc":"A utility library for encoding and decoding floats into 64-bit binaries that retain float sorting order. The ordering of floats is preserved when using ByteOrderedFloat to encode floats. For example, comparing floats a and b if float a is greater than float b then the encoding for a will be greater than the encoding for b . iex&gt; 1.0 &gt; - 1.0 true iex&gt; ByteOrderedFloat . encode ( 1.0 ) &gt; ByteOrderedFloat . encode ( - 1.0 ) true","ref":"readme.html","title":"ByteOrderedFloat","type":"extras"},{"doc":"Use ByteOrderedFloat.encode/1 to encode floats and ByteOrderedFloat.decode/1 to decode encoded floats. Encoding non-floats, or decoding invalid binaries or non-binaries will return :error iex&gt; ByteOrderedFloat . encode ( 0.1 ) { :ok , &lt;&lt; 191 , 185 , 153 , 153 , 153 , 153 , 153 , 154 &gt;&gt; } iex&gt; ByteOrderedFloat . decode ( &lt;&lt; 191 , 185 , 153 , 153 , 153 , 153 , 153 , 154 &gt;&gt; ) { :ok , 0.1 } iex&gt; ByteOrderedFloat . encode ( :not_a_float ) :error iex&gt; ByteOrderedFloat . decode ( &quot;not a valid float-encoding binary&quot; ) :error","ref":"readme.html#basic-usage","title":"ByteOrderedFloat - Basic Usage","type":"extras"},{"doc":"Zero Encoded 0.0 is the &quot;middle&quot; value; the leftmost bit is a 1 and all other bits are 0 . iex&gt; ByteOrderedFloat . encode ( 0.0 ) { :ok , &lt;&lt; 128 , 0 , 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; } Negatives Encoded negative floats are less than zero. # the most positive float iex&gt; ByteOrderedFloat . encode ( - 1.7976931348623157 E + 308 ) { :ok , &lt;&lt; 0 , 16 , 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; } # the nearest-to-zero negative float iex&gt; ByteOrderedFloat . encode ( - 1.7976931348623157E-308 ) { :ok , &lt;&lt; 127 , 243 , 18 , 189 , 19 , 119 , 162 , 98 &gt;&gt; } # a commonly used negative value: -1.0 iex&gt; ByteOrderedFloat . encode ( - 1.0 ) { :ok , &lt;&lt; 64 , 15 , 255 , 255 , 255 , 255 , 255 , 255 &gt;&gt; } Positives Encoded positives are greater than zero. # the most negative float iex&gt; ByteOrderedFloat . encode ( 1.7976931348623157 E + 308 ) { :ok , &lt;&lt; 255 , 239 , 255 , 255 , 255 , 255 , 255 , 255 &gt;&gt; } # the nearest-to-zero positive float iex&gt; ByteOrderedFloat . encode ( 1.7976931348623157E-308 ) { :ok , &lt;&lt; 128 , 12 , 237 , 66 , 236 , 136 , 93 , 157 &gt;&gt; } # a commonly used positive value: 1.0 iex&gt; ByteOrderedFloat . encode ( 1.0 ) { :ok , &lt;&lt; 191 , 240 , 0 , 0 , 0 , 0 , 0 , 0 &gt;&gt; }","ref":"readme.html#order-preservation","title":"ByteOrderedFloat - Order Preservation","type":"extras"},{"doc":"ByteOrderedFloat is available in Hex The package can be installed from hex by adding byte_ordered_float to your list of dependencies in mix.exs : def deps do [ { :byte_ordered_float , &quot;~&gt; 0.1.1&quot; } ] end","ref":"readme.html#installation","title":"ByteOrderedFloat - Installation","type":"extras"}]